(set-logic LRA)
(define-fun min ((a Real) (b Real)) Real (ite (<= a b) a b))
(define-fun max ((a Real) (b Real)) Real (ite (>= a b) a b))
(push 1)
  (declare-const ?rh Real)
  (push 1)
    (declare-const ?ri Real)
    (push 1)
      (assert
        (not (= ?rh ?ri))
        )
      (push 1)
        (push 1)
          (declare-const ?rj Real)
          (declare-const ?rk Real)
          (declare-const ?rl Real)
          (assert
            (not (= ?rj ?rl))
            )
          (push 1)
            (assert
              (and (= ?rl ?rh)
                (= ?rk ?ri)
                )
              )
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?rm Real)
        (assert
          (not (= ?rm ?rh))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?rn Real)
          (assert
            (not (= ?rn ?rh))
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?rm Real) )(and (not (= ?rm ?rh))
              (or (not (= ?ri ?rh))
                (not (= ?rm ?ri))
                )
              )
            )
          )
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (forall ((?rm Real) )(or (= ?rm ?rh)
                (and (= ?ri ?rh)
                  (= ?rm ?ri)
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?rm Real) )(and (not (= ?rm ?rh))
                (or (not (= ?ri ?rh))
                  (not (= ?rm ?ri))
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?rm Real) )(and (not (= ?rm ?rh))
              (or (not (= ?ri ?rh))
                (not (= ?rm ?ri))
                )
              )
            )
          )
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ro Real)
          (assert
            (not (= ?ro ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?rp Real)
          (declare-const ?rq Real)
          (declare-const ?rr Real)
          (assert
            (not (= ?rp ?rr))
            )
          (check-sat)
          (push 1)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?rs Real)
            (assert
              (not (= ?rs ?rh))
              )
            (check-sat)
            (pop 1)
          (push 1)
            (assert
              (or (and (= ?rr ?rh)
                  (= ?rq ?ri)
                  )
                (and (not (= ?rq ?rh))
                  (= ?rr ?ri)
                  )
                )
              )
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?rt Real)
          (assert
            (not (= ?rt ?rh))
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ru Real)
        (assert
          (not (= ?ru ?rh))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?rv Real)
          (assert
            (not (= ?rv ?rh))
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?rw Real)
        (declare-const ?rx Real)
        (assert
          (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                  (= ?rx ?ri)
                  )
                (and (not (= ?rx ?rh))
                  (= ?rr ?ri)
                  )
                )
              (not (= ?rw ?rr))
              )
            )
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ry Real)
          (assert
            (not (= ?ry ?rh))
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?rz Real)
          (assert
            (not (= ?rz ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?sa Real)
          (declare-const ?sb Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?sb ?ri)
                    )
                  (and (not (= ?sb ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?sa ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?sc Real)
        (assert
          (not (= ?sc ?rh))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?sd Real)
          (assert
            (not (= ?sd ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?se Real)
          (declare-const ?sf Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?sf ?ri)
                    )
                  (and (not (= ?sf ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?se ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?rw Real) (?rx Real) )(and (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                      (= ?rx ?ri)
                      )
                    (and (not (= ?rx ?rh))
                      (= ?rr ?ri)
                      )
                    )
                  (not (= ?rw ?rr))
                  )
                )
              (and (or (not (= ?rx ?rh))
                  (not (= ?rw ?ri))
                  )
                (or (= ?rw ?rh)
                  (not (= ?rx ?ri))
                  )
                )
              )
            )
          )
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (forall ((?rw Real) (?rx Real) )(or (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                        (not (= ?rx ?ri))
                        )
                      (or (= ?rx ?rh)
                        (not (= ?rr ?ri))
                        )
                      )
                    (= ?rw ?rr)
                    )
                  )
                (or (and (= ?rx ?rh)
                    (= ?rw ?ri)
                    )
                  (and (not (= ?rw ?rh))
                    (= ?rx ?ri)
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?rw Real) (?rx Real) )(and (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                        (= ?rx ?ri)
                        )
                      (and (not (= ?rx ?rh))
                        (= ?rr ?ri)
                        )
                      )
                    (not (= ?rw ?rr))
                    )
                  )
                (and (or (not (= ?rx ?rh))
                    (not (= ?rw ?ri))
                    )
                  (or (= ?rw ?rh)
                    (not (= ?rx ?ri))
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?sg Real)
        (assert
          (not (= ?sg ?rh))
          )
        (check-sat)
        (push 1)
          (assert
            (forall ((?rw Real) (?rx Real) )(or (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                        (not (= ?rx ?ri))
                        )
                      (or (= ?rx ?rh)
                        (not (= ?rr ?ri))
                        )
                      )
                    (= ?rw ?rr)
                    )
                  )
                (or (and (= ?rx ?rh)
                    (= ?rw ?ri)
                    )
                  (and (not (= ?rw ?rh))
                    (= ?rx ?ri)
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?rw Real) (?rx Real) )(and (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                        (= ?rx ?ri)
                        )
                      (and (not (= ?rx ?rh))
                        (= ?rr ?ri)
                        )
                      )
                    (not (= ?rw ?rr))
                    )
                  )
                (and (or (not (= ?rx ?rh))
                    (not (= ?rw ?ri))
                    )
                  (or (= ?rw ?rh)
                    (not (= ?rx ?ri))
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?rw Real) (?rx Real) )(and (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                      (= ?rx ?ri)
                      )
                    (and (not (= ?rx ?rh))
                      (= ?rr ?ri)
                      )
                    )
                  (not (= ?rw ?rr))
                  )
                )
              (and (or (not (= ?rx ?rh))
                  (not (= ?rw ?ri))
                  )
                (or (= ?rw ?rh)
                  (not (= ?rx ?ri))
                  )
                )
              )
            )
          )
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?sh Real)
          (assert
            (not (= ?sh ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?si Real)
          (declare-const ?sj Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?sj ?ri)
                    )
                  (and (not (= ?sj ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?si ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?sk Real)
          (declare-const ?sl Real)
          (declare-const ?sm Real)
          (assert
            (not (= ?sk ?sm))
            )
          (check-sat)
          (push 1)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?sn Real)
            (assert
              (not (= ?sn ?rh))
              )
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?so Real)
            (declare-const ?sp Real)
            (assert
              (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                      (= ?sp ?ri)
                      )
                    (and (not (= ?sp ?rh))
                      (= ?rr ?ri)
                      )
                    )
                  (not (= ?so ?rr))
                  )
                )
              )
            (check-sat)
            (pop 1)
          (push 1)
            (assert
              (or (or (and (= ?sm ?rh)
                    (= ?sl ?ri)
                    )
                  (and (not (= ?sl ?rh))
                    (= ?sm ?ri)
                    )
                  )
                (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                        (= ?sm ?ri)
                        )
                      (and (not (= ?sm ?rh))
                        (= ?rr ?ri)
                        )
                      )
                    (not (= ?sl ?rr))
                    )
                  )
                )
              )
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?sq Real)
          (assert
            (not (= ?sq ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?sr Real)
          (declare-const ?ss Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?ss ?ri)
                    )
                  (and (not (= ?ss ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?sr ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?st Real)
        (assert
          (not (= ?st ?rh))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?su Real)
          (assert
            (not (= ?su ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?sv Real)
          (declare-const ?sw Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?sw ?ri)
                    )
                  (and (not (= ?sw ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?sv ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?sx Real)
        (declare-const ?sy Real)
        (assert
          (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                  (= ?sy ?ri)
                  )
                (and (not (= ?sy ?rh))
                  (= ?rr ?ri)
                  )
                )
              (not (= ?sx ?rr))
              )
            )
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?sz Real)
          (assert
            (not (= ?sz ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ta Real)
          (declare-const ?tb Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?tb ?ri)
                    )
                  (and (not (= ?tb ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?ta ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?tc Real)
        (declare-const ?td Real)
        (push 1)
          (declare-const ?te Real)
          (assert
            (not (= ?te ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?tf Real)
          (declare-const ?tg Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?tg ?ri)
                    )
                  (and (not (= ?tg ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?tf ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?th Real)
          (assert
            (not (= ?th ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ti Real)
          (declare-const ?tj Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?tj ?ri)
                    )
                  (and (not (= ?tj ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?ti ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?tk Real)
        (assert
          (not (= ?tk ?rh))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?tl Real)
          (assert
            (not (= ?tl ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?tm Real)
          (declare-const ?tn Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?tn ?ri)
                    )
                  (and (not (= ?tn ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?tm ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?to Real)
          (declare-const ?tp Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?tq Real)
        (declare-const ?tr Real)
        (assert
          (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                  (= ?tr ?ri)
                  )
                (and (not (= ?tr ?rh))
                  (= ?rr ?ri)
                  )
                )
              (not (= ?tq ?rr))
              )
            )
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ts Real)
          (assert
            (not (= ?ts ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?tt Real)
          (declare-const ?tu Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?tu ?ri)
                    )
                  (and (not (= ?tu ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?tt ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?tv Real)
          (declare-const ?tw Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (or (exists ((?sx Real) (?sy Real) )(and (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                        (= ?sy ?ri)
                        )
                      (and (not (= ?sy ?rh))
                        (= ?rr ?ri)
                        )
                      )
                    (not (= ?sx ?rr))
                    )
                  )
                (and (and (or (not (= ?sy ?rh))
                      (not (= ?sx ?ri))
                      )
                    (or (= ?sx ?rh)
                      (not (= ?sy ?ri))
                      )
                    )
                  (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                          (not (= ?sy ?ri))
                          )
                        (or (= ?sy ?rh)
                          (not (= ?rr ?ri))
                          )
                        )
                      (= ?sx ?rr)
                      )
                    )
                  )
                )
              )
            (exists ((?tc Real) (?td Real) )(and (and (or (not (= ?td ?rh))
                    (not (= ?tc ?ri))
                    )
                  (or (= ?tc ?rh)
                    (not (= ?td ?ri))
                    )
                  )
                (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                        (not (= ?td ?ri))
                        )
                      (or (= ?td ?rh)
                        (not (= ?rr ?ri))
                        )
                      )
                    (= ?tc ?rr)
                    )
                  )
                )
              )
            )
          )
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (and (forall ((?sx Real) (?sy Real) )(or (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                          (not (= ?sy ?ri))
                          )
                        (or (= ?sy ?rh)
                          (not (= ?rr ?ri))
                          )
                        )
                      (= ?sx ?rr)
                      )
                    )
                  (or (or (and (= ?sy ?rh)
                        (= ?sx ?ri)
                        )
                      (and (not (= ?sx ?rh))
                        (= ?sy ?ri)
                        )
                      )
                    (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                            (= ?sy ?ri)
                            )
                          (and (not (= ?sy ?rh))
                            (= ?rr ?ri)
                            )
                          )
                        (not (= ?sx ?rr))
                        )
                      )
                    )
                  )
                )
              (forall ((?tc Real) (?td Real) )(or (or (and (= ?td ?rh)
                      (= ?tc ?ri)
                      )
                    (and (not (= ?tc ?rh))
                      (= ?td ?ri)
                      )
                    )
                  (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                          (= ?td ?ri)
                          )
                        (and (not (= ?td ?rh))
                          (= ?rr ?ri)
                          )
                        )
                      (not (= ?tc ?rr))
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (exists ((?sx Real) (?sy Real) )(and (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                          (= ?sy ?ri)
                          )
                        (and (not (= ?sy ?rh))
                          (= ?rr ?ri)
                          )
                        )
                      (not (= ?sx ?rr))
                      )
                    )
                  (and (and (or (not (= ?sy ?rh))
                        (not (= ?sx ?ri))
                        )
                      (or (= ?sx ?rh)
                        (not (= ?sy ?ri))
                        )
                      )
                    (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                            (not (= ?sy ?ri))
                            )
                          (or (= ?sy ?rh)
                            (not (= ?rr ?ri))
                            )
                          )
                        (= ?sx ?rr)
                        )
                      )
                    )
                  )
                )
              (exists ((?tc Real) (?td Real) )(and (and (or (not (= ?td ?rh))
                      (not (= ?tc ?ri))
                      )
                    (or (= ?tc ?rh)
                      (not (= ?td ?ri))
                      )
                    )
                  (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                          (not (= ?td ?ri))
                          )
                        (or (= ?td ?rh)
                          (not (= ?rr ?ri))
                          )
                        )
                      (= ?tc ?rr)
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?tx Real)
        (assert
          (not (= ?tx ?rh))
          )
        (check-sat)
        (push 1)
          (assert
            (and (forall ((?sx Real) (?sy Real) )(or (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                          (not (= ?sy ?ri))
                          )
                        (or (= ?sy ?rh)
                          (not (= ?rr ?ri))
                          )
                        )
                      (= ?sx ?rr)
                      )
                    )
                  (or (or (and (= ?sy ?rh)
                        (= ?sx ?ri)
                        )
                      (and (not (= ?sx ?rh))
                        (= ?sy ?ri)
                        )
                      )
                    (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                            (= ?sy ?ri)
                            )
                          (and (not (= ?sy ?rh))
                            (= ?rr ?ri)
                            )
                          )
                        (not (= ?sx ?rr))
                        )
                      )
                    )
                  )
                )
              (forall ((?tc Real) (?td Real) )(or (or (and (= ?td ?rh)
                      (= ?tc ?ri)
                      )
                    (and (not (= ?tc ?rh))
                      (= ?td ?ri)
                      )
                    )
                  (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                          (= ?td ?ri)
                          )
                        (and (not (= ?td ?rh))
                          (= ?rr ?ri)
                          )
                        )
                      (not (= ?tc ?rr))
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (exists ((?sx Real) (?sy Real) )(and (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                          (= ?sy ?ri)
                          )
                        (and (not (= ?sy ?rh))
                          (= ?rr ?ri)
                          )
                        )
                      (not (= ?sx ?rr))
                      )
                    )
                  (and (and (or (not (= ?sy ?rh))
                        (not (= ?sx ?ri))
                        )
                      (or (= ?sx ?rh)
                        (not (= ?sy ?ri))
                        )
                      )
                    (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                            (not (= ?sy ?ri))
                            )
                          (or (= ?sy ?rh)
                            (not (= ?rr ?ri))
                            )
                          )
                        (= ?sx ?rr)
                        )
                      )
                    )
                  )
                )
              (exists ((?tc Real) (?td Real) )(and (and (or (not (= ?td ?rh))
                      (not (= ?tc ?ri))
                      )
                    (or (= ?tc ?rh)
                      (not (= ?td ?ri))
                      )
                    )
                  (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                          (not (= ?td ?ri))
                          )
                        (or (= ?td ?rh)
                          (not (= ?rr ?ri))
                          )
                        )
                      (= ?tc ?rr)
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ty Real)
        (declare-const ?tz Real)
        (assert
          (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                  (= ?tz ?ri)
                  )
                (and (not (= ?tz ?rh))
                  (= ?rr ?ri)
                  )
                )
              (not (= ?ty ?rr))
              )
            )
          )
        (check-sat)
        (push 1)
          (assert
            (and (forall ((?sx Real) (?sy Real) )(or (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                          (not (= ?sy ?ri))
                          )
                        (or (= ?sy ?rh)
                          (not (= ?rr ?ri))
                          )
                        )
                      (= ?sx ?rr)
                      )
                    )
                  (or (or (and (= ?sy ?rh)
                        (= ?sx ?ri)
                        )
                      (and (not (= ?sx ?rh))
                        (= ?sy ?ri)
                        )
                      )
                    (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                            (= ?sy ?ri)
                            )
                          (and (not (= ?sy ?rh))
                            (= ?rr ?ri)
                            )
                          )
                        (not (= ?sx ?rr))
                        )
                      )
                    )
                  )
                )
              (forall ((?tc Real) (?td Real) )(or (or (and (= ?td ?rh)
                      (= ?tc ?ri)
                      )
                    (and (not (= ?tc ?rh))
                      (= ?td ?ri)
                      )
                    )
                  (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                          (= ?td ?ri)
                          )
                        (and (not (= ?td ?rh))
                          (= ?rr ?ri)
                          )
                        )
                      (not (= ?tc ?rr))
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (exists ((?sx Real) (?sy Real) )(and (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                          (= ?sy ?ri)
                          )
                        (and (not (= ?sy ?rh))
                          (= ?rr ?ri)
                          )
                        )
                      (not (= ?sx ?rr))
                      )
                    )
                  (and (and (or (not (= ?sy ?rh))
                        (not (= ?sx ?ri))
                        )
                      (or (= ?sx ?rh)
                        (not (= ?sy ?ri))
                        )
                      )
                    (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                            (not (= ?sy ?ri))
                            )
                          (or (= ?sy ?rh)
                            (not (= ?rr ?ri))
                            )
                          )
                        (= ?sx ?rr)
                        )
                      )
                    )
                  )
                )
              (exists ((?tc Real) (?td Real) )(and (and (or (not (= ?td ?rh))
                      (not (= ?tc ?ri))
                      )
                    (or (= ?tc ?rh)
                      (not (= ?td ?ri))
                      )
                    )
                  (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                          (not (= ?td ?ri))
                          )
                        (or (= ?td ?rh)
                          (not (= ?rr ?ri))
                          )
                        )
                      (= ?tc ?rr)
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (or (exists ((?sx Real) (?sy Real) )(and (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                        (= ?sy ?ri)
                        )
                      (and (not (= ?sy ?rh))
                        (= ?rr ?ri)
                        )
                      )
                    (not (= ?sx ?rr))
                    )
                  )
                (and (and (or (not (= ?sy ?rh))
                      (not (= ?sx ?ri))
                      )
                    (or (= ?sx ?rh)
                      (not (= ?sy ?ri))
                      )
                    )
                  (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                          (not (= ?sy ?ri))
                          )
                        (or (= ?sy ?rh)
                          (not (= ?rr ?ri))
                          )
                        )
                      (= ?sx ?rr)
                      )
                    )
                  )
                )
              )
            (exists ((?tc Real) (?td Real) )(and (and (or (not (= ?td ?rh))
                    (not (= ?tc ?ri))
                    )
                  (or (= ?tc ?rh)
                    (not (= ?td ?ri))
                    )
                  )
                (forall ((?rr Real) )(or (and (or (not (= ?rr ?rh))
                        (not (= ?td ?ri))
                        )
                      (or (= ?td ?rh)
                        (not (= ?rr ?ri))
                        )
                      )
                    (= ?tc ?rr)
                    )
                  )
                )
              )
            )
          )
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ua Real)
          (assert
            (not (= ?ua ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ub Real)
          (declare-const ?uc Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?uc ?ri)
                    )
                  (and (not (= ?uc ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?ub ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ud Real)
          (declare-const ?ue Real)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?uf Real)
          (declare-const ?ug Real)
          (declare-const ?uh Real)
          (assert
            (not (= ?uf ?uh))
            )
          (check-sat)
          (push 1)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?ui Real)
            (assert
              (not (= ?ui ?rh))
              )
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?uj Real)
            (declare-const ?uk Real)
            (assert
              (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                      (= ?uk ?ri)
                      )
                    (and (not (= ?uk ?rh))
                      (= ?rr ?ri)
                      )
                    )
                  (not (= ?uj ?rr))
                  )
                )
              )
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?ul Real)
            (declare-const ?um Real)
            (check-sat)
            (pop 1)
          (push 1)
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?un Real)
          (assert
            (not (= ?un ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?uo Real)
          (declare-const ?up Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?up ?ri)
                    )
                  (and (not (= ?up ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?uo ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?uq Real)
        (assert
          (not (= ?uq ?rh))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ur Real)
          (assert
            (not (= ?ur ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?us Real)
          (declare-const ?ut Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?ut ?ri)
                    )
                  (and (not (= ?ut ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?us ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?uu Real)
          (declare-const ?uv Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?uw Real)
        (declare-const ?ux Real)
        (assert
          (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                  (= ?ux ?ri)
                  )
                (and (not (= ?ux ?rh))
                  (= ?rr ?ri)
                  )
                )
              (not (= ?uw ?rr))
              )
            )
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?uy Real)
          (assert
            (not (= ?uy ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?uz Real)
          (declare-const ?va Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?va ?ri)
                    )
                  (and (not (= ?va ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?uz ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?vb Real)
          (declare-const ?vc Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?vd Real)
        (declare-const ?ve Real)
        (push 1)
          (declare-const ?vf Real)
          (assert
            (not (= ?vf ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?vg Real)
          (declare-const ?vh Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?vh ?ri)
                    )
                  (and (not (= ?vh ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?vg ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?vi Real)
        (declare-const ?vj Real)
        (push 1)
          (declare-const ?vk Real)
          (assert
            (not (= ?vk ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?vl Real)
          (declare-const ?vm Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?vm ?ri)
                    )
                  (and (not (= ?vm ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?vl ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?vn Real)
          (assert
            (not (= ?vn ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?vo Real)
          (declare-const ?vp Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?vp ?ri)
                    )
                  (and (not (= ?vp ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?vo ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?vq Real)
        (assert
          (not (= ?vq ?rh))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?vr Real)
          (assert
            (not (= ?vr ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?vs Real)
          (declare-const ?vt Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?vt ?ri)
                    )
                  (and (not (= ?vt ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?vs ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?vu Real)
          (declare-const ?vv Real)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?vw Real)
          (declare-const ?vx Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?vy Real)
        (declare-const ?vz Real)
        (assert
          (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                  (= ?vz ?ri)
                  )
                (and (not (= ?vz ?rh))
                  (= ?rr ?ri)
                  )
                )
              (not (= ?vy ?rr))
              )
            )
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?wa Real)
          (assert
            (not (= ?wa ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?wb Real)
          (declare-const ?wc Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?wc ?ri)
                    )
                  (and (not (= ?wc ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?wb ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?wd Real)
          (declare-const ?we Real)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?wf Real)
          (declare-const ?wg Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?wh Real)
        (declare-const ?wi Real)
        (push 1)
          (declare-const ?wj Real)
          (assert
            (not (= ?wj ?rh))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?wk Real)
          (declare-const ?wl Real)
          (assert
            (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                    (= ?wl ?ri)
                    )
                  (and (not (= ?wl ?rh))
                    (= ?rr ?ri)
                    )
                  )
                (not (= ?wk ?rr))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?wm Real)
        (assert
          (not (= ?wm ?rh))
          )
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?wn Real)
        (declare-const ?wo Real)
        (assert
          (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                  (= ?wo ?ri)
                  )
                (and (not (= ?wo ?rh))
                  (= ?rr ?ri)
                  )
                )
              (not (= ?wn ?rr))
              )
            )
          )
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?wp Real)
        (assert
          (not (= ?wp ?rh))
          )
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?wq Real)
        (declare-const ?wr Real)
        (assert
          (exists ((?rr Real) )(and (or (and (= ?rr ?rh)
                  (= ?wr ?ri)
                  )
                (and (not (= ?wr ?rh))
                  (= ?rr ?ri)
                  )
                )
              (not (= ?wq ?rr))
              )
            )
          )
        (check-sat)
        (exit)

