(set-logic LRA)
(define-fun min ((a Real) (b Real)) Real (ite (<= a b) a b))
(define-fun max ((a Real) (b Real)) Real (ite (>= a b) a b))
(push 1)
  (declare-const ?lt Real)
  (push 1)
    (declare-const ?lu Real)
    (push 1)
      (assert
        (not (= ?lt ?lu))
        )
      (push 1)
        (push 1)
          (declare-const ?lv Real)
          (declare-const ?lw Real)
          (declare-const ?lx Real)
          (assert
            (not (= ?lv ?lx))
            )
          (push 1)
            (assert
              (and (= ?lx ?lt)
                (= ?lw ?lu)
                )
              )
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ly Real)
        (assert
          (not (= ?ly ?lt))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?lz Real)
          (assert
            (not (= ?lz ?lt))
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?ly Real) )(and (not (= ?ly ?lt))
              (or (not (= ?lu ?lt))
                (not (= ?ly ?lu))
                )
              )
            )
          )
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (forall ((?ly Real) )(or (= ?ly ?lt)
                (and (= ?lu ?lt)
                  (= ?ly ?lu)
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?ly Real) )(and (not (= ?ly ?lt))
                (or (not (= ?lu ?lt))
                  (not (= ?ly ?lu))
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?ly Real) )(and (not (= ?ly ?lt))
              (or (not (= ?lu ?lt))
                (not (= ?ly ?lu))
                )
              )
            )
          )
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ma Real)
          (assert
            (not (= ?ma ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?mb Real)
          (declare-const ?mc Real)
          (declare-const ?md Real)
          (assert
            (not (= ?mb ?md))
            )
          (check-sat)
          (push 1)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?me Real)
            (assert
              (not (= ?me ?lt))
              )
            (check-sat)
            (pop 1)
          (push 1)
            (assert
              (or (and (= ?md ?lt)
                  (= ?mc ?lu)
                  )
                (and (not (= ?mc ?lt))
                  (= ?md ?lu)
                  )
                )
              )
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?mf Real)
          (assert
            (not (= ?mf ?lt))
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?mg Real)
        (assert
          (not (= ?mg ?lt))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?mh Real)
          (assert
            (not (= ?mh ?lt))
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?mi Real)
        (declare-const ?mj Real)
        (assert
          (exists ((?md Real) )(and (or (and (= ?md ?lt)
                  (= ?mj ?lu)
                  )
                (and (not (= ?mj ?lt))
                  (= ?md ?lu)
                  )
                )
              (not (= ?mi ?md))
              )
            )
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?mk Real)
          (assert
            (not (= ?mk ?lt))
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?ml Real)
          (assert
            (not (= ?ml ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?mm Real)
          (declare-const ?mn Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?mn ?lu)
                    )
                  (and (not (= ?mn ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?mm ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?mo Real)
        (assert
          (not (= ?mo ?lt))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?mp Real)
          (assert
            (not (= ?mp ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?mq Real)
          (declare-const ?mr Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?mr ?lu)
                    )
                  (and (not (= ?mr ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?mq ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?mi Real) (?mj Real) )(and (exists ((?md Real) )(and (or (and (= ?md ?lt)
                      (= ?mj ?lu)
                      )
                    (and (not (= ?mj ?lt))
                      (= ?md ?lu)
                      )
                    )
                  (not (= ?mi ?md))
                  )
                )
              (and (or (not (= ?mj ?lt))
                  (not (= ?mi ?lu))
                  )
                (or (= ?mi ?lt)
                  (not (= ?mj ?lu))
                  )
                )
              )
            )
          )
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (forall ((?mi Real) (?mj Real) )(or (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                        (not (= ?mj ?lu))
                        )
                      (or (= ?mj ?lt)
                        (not (= ?md ?lu))
                        )
                      )
                    (= ?mi ?md)
                    )
                  )
                (or (and (= ?mj ?lt)
                    (= ?mi ?lu)
                    )
                  (and (not (= ?mi ?lt))
                    (= ?mj ?lu)
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?mi Real) (?mj Real) )(and (exists ((?md Real) )(and (or (and (= ?md ?lt)
                        (= ?mj ?lu)
                        )
                      (and (not (= ?mj ?lt))
                        (= ?md ?lu)
                        )
                      )
                    (not (= ?mi ?md))
                    )
                  )
                (and (or (not (= ?mj ?lt))
                    (not (= ?mi ?lu))
                    )
                  (or (= ?mi ?lt)
                    (not (= ?mj ?lu))
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ms Real)
        (assert
          (not (= ?ms ?lt))
          )
        (check-sat)
        (push 1)
          (assert
            (forall ((?mi Real) (?mj Real) )(or (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                        (not (= ?mj ?lu))
                        )
                      (or (= ?mj ?lt)
                        (not (= ?md ?lu))
                        )
                      )
                    (= ?mi ?md)
                    )
                  )
                (or (and (= ?mj ?lt)
                    (= ?mi ?lu)
                    )
                  (and (not (= ?mi ?lt))
                    (= ?mj ?lu)
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?mi Real) (?mj Real) )(and (exists ((?md Real) )(and (or (and (= ?md ?lt)
                        (= ?mj ?lu)
                        )
                      (and (not (= ?mj ?lt))
                        (= ?md ?lu)
                        )
                      )
                    (not (= ?mi ?md))
                    )
                  )
                (and (or (not (= ?mj ?lt))
                    (not (= ?mi ?lu))
                    )
                  (or (= ?mi ?lt)
                    (not (= ?mj ?lu))
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?mi Real) (?mj Real) )(and (exists ((?md Real) )(and (or (and (= ?md ?lt)
                      (= ?mj ?lu)
                      )
                    (and (not (= ?mj ?lt))
                      (= ?md ?lu)
                      )
                    )
                  (not (= ?mi ?md))
                  )
                )
              (and (or (not (= ?mj ?lt))
                  (not (= ?mi ?lu))
                  )
                (or (= ?mi ?lt)
                  (not (= ?mj ?lu))
                  )
                )
              )
            )
          )
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?mt Real)
          (assert
            (not (= ?mt ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?mu Real)
          (declare-const ?mv Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?mv ?lu)
                    )
                  (and (not (= ?mv ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?mu ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?mw Real)
          (declare-const ?mx Real)
          (declare-const ?my Real)
          (assert
            (not (= ?mw ?my))
            )
          (check-sat)
          (push 1)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?mz Real)
            (assert
              (not (= ?mz ?lt))
              )
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?na Real)
            (declare-const ?nb Real)
            (assert
              (exists ((?md Real) )(and (or (and (= ?md ?lt)
                      (= ?nb ?lu)
                      )
                    (and (not (= ?nb ?lt))
                      (= ?md ?lu)
                      )
                    )
                  (not (= ?na ?md))
                  )
                )
              )
            (check-sat)
            (pop 1)
          (push 1)
            (assert
              (or (or (and (= ?my ?lt)
                    (= ?mx ?lu)
                    )
                  (and (not (= ?mx ?lt))
                    (= ?my ?lu)
                    )
                  )
                (exists ((?md Real) )(and (or (and (= ?md ?lt)
                        (= ?my ?lu)
                        )
                      (and (not (= ?my ?lt))
                        (= ?md ?lu)
                        )
                      )
                    (not (= ?mx ?md))
                    )
                  )
                )
              )
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?nc Real)
          (assert
            (not (= ?nc ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?nd Real)
          (declare-const ?ne Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?ne ?lu)
                    )
                  (and (not (= ?ne ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?nd ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?nf Real)
        (assert
          (not (= ?nf ?lt))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ng Real)
          (assert
            (not (= ?ng ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?nh Real)
          (declare-const ?ni Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?ni ?lu)
                    )
                  (and (not (= ?ni ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?nh ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?nj Real)
        (declare-const ?nk Real)
        (assert
          (exists ((?md Real) )(and (or (and (= ?md ?lt)
                  (= ?nk ?lu)
                  )
                (and (not (= ?nk ?lt))
                  (= ?md ?lu)
                  )
                )
              (not (= ?nj ?md))
              )
            )
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?nl Real)
          (assert
            (not (= ?nl ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?nm Real)
          (declare-const ?nn Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?nn ?lu)
                    )
                  (and (not (= ?nn ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?nm ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?no Real)
        (declare-const ?np Real)
        (push 1)
          (declare-const ?nq Real)
          (assert
            (not (= ?nq ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?nr Real)
          (declare-const ?ns Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?ns ?lu)
                    )
                  (and (not (= ?ns ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?nr ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?nt Real)
          (assert
            (not (= ?nt ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?nu Real)
          (declare-const ?nv Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?nv ?lu)
                    )
                  (and (not (= ?nv ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?nu ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?nw Real)
        (assert
          (not (= ?nw ?lt))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?nx Real)
          (assert
            (not (= ?nx ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ny Real)
          (declare-const ?nz Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?nz ?lu)
                    )
                  (and (not (= ?nz ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?ny ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?oa Real)
          (declare-const ?ob Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?oc Real)
        (declare-const ?od Real)
        (assert
          (exists ((?md Real) )(and (or (and (= ?md ?lt)
                  (= ?od ?lu)
                  )
                (and (not (= ?od ?lt))
                  (= ?md ?lu)
                  )
                )
              (not (= ?oc ?md))
              )
            )
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?oe Real)
          (assert
            (not (= ?oe ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?of Real)
          (declare-const ?og Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?og ?lu)
                    )
                  (and (not (= ?og ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?of ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?oh Real)
          (declare-const ?oi Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (or (exists ((?nj Real) (?nk Real) )(and (exists ((?md Real) )(and (or (and (= ?md ?lt)
                        (= ?nk ?lu)
                        )
                      (and (not (= ?nk ?lt))
                        (= ?md ?lu)
                        )
                      )
                    (not (= ?nj ?md))
                    )
                  )
                (and (and (or (not (= ?nk ?lt))
                      (not (= ?nj ?lu))
                      )
                    (or (= ?nj ?lt)
                      (not (= ?nk ?lu))
                      )
                    )
                  (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                          (not (= ?nk ?lu))
                          )
                        (or (= ?nk ?lt)
                          (not (= ?md ?lu))
                          )
                        )
                      (= ?nj ?md)
                      )
                    )
                  )
                )
              )
            (exists ((?no Real) (?np Real) )(and (and (or (not (= ?np ?lt))
                    (not (= ?no ?lu))
                    )
                  (or (= ?no ?lt)
                    (not (= ?np ?lu))
                    )
                  )
                (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                        (not (= ?np ?lu))
                        )
                      (or (= ?np ?lt)
                        (not (= ?md ?lu))
                        )
                      )
                    (= ?no ?md)
                    )
                  )
                )
              )
            )
          )
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (and (forall ((?nj Real) (?nk Real) )(or (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                          (not (= ?nk ?lu))
                          )
                        (or (= ?nk ?lt)
                          (not (= ?md ?lu))
                          )
                        )
                      (= ?nj ?md)
                      )
                    )
                  (or (or (and (= ?nk ?lt)
                        (= ?nj ?lu)
                        )
                      (and (not (= ?nj ?lt))
                        (= ?nk ?lu)
                        )
                      )
                    (exists ((?md Real) )(and (or (and (= ?md ?lt)
                            (= ?nk ?lu)
                            )
                          (and (not (= ?nk ?lt))
                            (= ?md ?lu)
                            )
                          )
                        (not (= ?nj ?md))
                        )
                      )
                    )
                  )
                )
              (forall ((?no Real) (?np Real) )(or (or (and (= ?np ?lt)
                      (= ?no ?lu)
                      )
                    (and (not (= ?no ?lt))
                      (= ?np ?lu)
                      )
                    )
                  (exists ((?md Real) )(and (or (and (= ?md ?lt)
                          (= ?np ?lu)
                          )
                        (and (not (= ?np ?lt))
                          (= ?md ?lu)
                          )
                        )
                      (not (= ?no ?md))
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (exists ((?nj Real) (?nk Real) )(and (exists ((?md Real) )(and (or (and (= ?md ?lt)
                          (= ?nk ?lu)
                          )
                        (and (not (= ?nk ?lt))
                          (= ?md ?lu)
                          )
                        )
                      (not (= ?nj ?md))
                      )
                    )
                  (and (and (or (not (= ?nk ?lt))
                        (not (= ?nj ?lu))
                        )
                      (or (= ?nj ?lt)
                        (not (= ?nk ?lu))
                        )
                      )
                    (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                            (not (= ?nk ?lu))
                            )
                          (or (= ?nk ?lt)
                            (not (= ?md ?lu))
                            )
                          )
                        (= ?nj ?md)
                        )
                      )
                    )
                  )
                )
              (exists ((?no Real) (?np Real) )(and (and (or (not (= ?np ?lt))
                      (not (= ?no ?lu))
                      )
                    (or (= ?no ?lt)
                      (not (= ?np ?lu))
                      )
                    )
                  (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                          (not (= ?np ?lu))
                          )
                        (or (= ?np ?lt)
                          (not (= ?md ?lu))
                          )
                        )
                      (= ?no ?md)
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?oj Real)
        (assert
          (not (= ?oj ?lt))
          )
        (check-sat)
        (push 1)
          (assert
            (and (forall ((?nj Real) (?nk Real) )(or (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                          (not (= ?nk ?lu))
                          )
                        (or (= ?nk ?lt)
                          (not (= ?md ?lu))
                          )
                        )
                      (= ?nj ?md)
                      )
                    )
                  (or (or (and (= ?nk ?lt)
                        (= ?nj ?lu)
                        )
                      (and (not (= ?nj ?lt))
                        (= ?nk ?lu)
                        )
                      )
                    (exists ((?md Real) )(and (or (and (= ?md ?lt)
                            (= ?nk ?lu)
                            )
                          (and (not (= ?nk ?lt))
                            (= ?md ?lu)
                            )
                          )
                        (not (= ?nj ?md))
                        )
                      )
                    )
                  )
                )
              (forall ((?no Real) (?np Real) )(or (or (and (= ?np ?lt)
                      (= ?no ?lu)
                      )
                    (and (not (= ?no ?lt))
                      (= ?np ?lu)
                      )
                    )
                  (exists ((?md Real) )(and (or (and (= ?md ?lt)
                          (= ?np ?lu)
                          )
                        (and (not (= ?np ?lt))
                          (= ?md ?lu)
                          )
                        )
                      (not (= ?no ?md))
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (exists ((?nj Real) (?nk Real) )(and (exists ((?md Real) )(and (or (and (= ?md ?lt)
                          (= ?nk ?lu)
                          )
                        (and (not (= ?nk ?lt))
                          (= ?md ?lu)
                          )
                        )
                      (not (= ?nj ?md))
                      )
                    )
                  (and (and (or (not (= ?nk ?lt))
                        (not (= ?nj ?lu))
                        )
                      (or (= ?nj ?lt)
                        (not (= ?nk ?lu))
                        )
                      )
                    (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                            (not (= ?nk ?lu))
                            )
                          (or (= ?nk ?lt)
                            (not (= ?md ?lu))
                            )
                          )
                        (= ?nj ?md)
                        )
                      )
                    )
                  )
                )
              (exists ((?no Real) (?np Real) )(and (and (or (not (= ?np ?lt))
                      (not (= ?no ?lu))
                      )
                    (or (= ?no ?lt)
                      (not (= ?np ?lu))
                      )
                    )
                  (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                          (not (= ?np ?lu))
                          )
                        (or (= ?np ?lt)
                          (not (= ?md ?lu))
                          )
                        )
                      (= ?no ?md)
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ok Real)
        (declare-const ?ol Real)
        (assert
          (exists ((?md Real) )(and (or (and (= ?md ?lt)
                  (= ?ol ?lu)
                  )
                (and (not (= ?ol ?lt))
                  (= ?md ?lu)
                  )
                )
              (not (= ?ok ?md))
              )
            )
          )
        (check-sat)
        (push 1)
          (assert
            (and (forall ((?nj Real) (?nk Real) )(or (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                          (not (= ?nk ?lu))
                          )
                        (or (= ?nk ?lt)
                          (not (= ?md ?lu))
                          )
                        )
                      (= ?nj ?md)
                      )
                    )
                  (or (or (and (= ?nk ?lt)
                        (= ?nj ?lu)
                        )
                      (and (not (= ?nj ?lt))
                        (= ?nk ?lu)
                        )
                      )
                    (exists ((?md Real) )(and (or (and (= ?md ?lt)
                            (= ?nk ?lu)
                            )
                          (and (not (= ?nk ?lt))
                            (= ?md ?lu)
                            )
                          )
                        (not (= ?nj ?md))
                        )
                      )
                    )
                  )
                )
              (forall ((?no Real) (?np Real) )(or (or (and (= ?np ?lt)
                      (= ?no ?lu)
                      )
                    (and (not (= ?no ?lt))
                      (= ?np ?lu)
                      )
                    )
                  (exists ((?md Real) )(and (or (and (= ?md ?lt)
                          (= ?np ?lu)
                          )
                        (and (not (= ?np ?lt))
                          (= ?md ?lu)
                          )
                        )
                      (not (= ?no ?md))
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (exists ((?nj Real) (?nk Real) )(and (exists ((?md Real) )(and (or (and (= ?md ?lt)
                          (= ?nk ?lu)
                          )
                        (and (not (= ?nk ?lt))
                          (= ?md ?lu)
                          )
                        )
                      (not (= ?nj ?md))
                      )
                    )
                  (and (and (or (not (= ?nk ?lt))
                        (not (= ?nj ?lu))
                        )
                      (or (= ?nj ?lt)
                        (not (= ?nk ?lu))
                        )
                      )
                    (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                            (not (= ?nk ?lu))
                            )
                          (or (= ?nk ?lt)
                            (not (= ?md ?lu))
                            )
                          )
                        (= ?nj ?md)
                        )
                      )
                    )
                  )
                )
              (exists ((?no Real) (?np Real) )(and (and (or (not (= ?np ?lt))
                      (not (= ?no ?lu))
                      )
                    (or (= ?no ?lt)
                      (not (= ?np ?lu))
                      )
                    )
                  (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                          (not (= ?np ?lu))
                          )
                        (or (= ?np ?lt)
                          (not (= ?md ?lu))
                          )
                        )
                      (= ?no ?md)
                      )
                    )
                  )
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (or (exists ((?nj Real) (?nk Real) )(and (exists ((?md Real) )(and (or (and (= ?md ?lt)
                        (= ?nk ?lu)
                        )
                      (and (not (= ?nk ?lt))
                        (= ?md ?lu)
                        )
                      )
                    (not (= ?nj ?md))
                    )
                  )
                (and (and (or (not (= ?nk ?lt))
                      (not (= ?nj ?lu))
                      )
                    (or (= ?nj ?lt)
                      (not (= ?nk ?lu))
                      )
                    )
                  (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                          (not (= ?nk ?lu))
                          )
                        (or (= ?nk ?lt)
                          (not (= ?md ?lu))
                          )
                        )
                      (= ?nj ?md)
                      )
                    )
                  )
                )
              )
            (exists ((?no Real) (?np Real) )(and (and (or (not (= ?np ?lt))
                    (not (= ?no ?lu))
                    )
                  (or (= ?no ?lt)
                    (not (= ?np ?lu))
                    )
                  )
                (forall ((?md Real) )(or (and (or (not (= ?md ?lt))
                        (not (= ?np ?lu))
                        )
                      (or (= ?np ?lt)
                        (not (= ?md ?lu))
                        )
                      )
                    (= ?no ?md)
                    )
                  )
                )
              )
            )
          )
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?om Real)
          (assert
            (not (= ?om ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?on Real)
          (declare-const ?oo Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?oo ?lu)
                    )
                  (and (not (= ?oo ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?on ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?op Real)
          (declare-const ?oq Real)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?or Real)
          (declare-const ?os Real)
          (declare-const ?ot Real)
          (assert
            (not (= ?or ?ot))
            )
          (check-sat)
          (push 1)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?ou Real)
            (assert
              (not (= ?ou ?lt))
              )
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?ov Real)
            (declare-const ?ow Real)
            (assert
              (exists ((?md Real) )(and (or (and (= ?md ?lt)
                      (= ?ow ?lu)
                      )
                    (and (not (= ?ow ?lt))
                      (= ?md ?lu)
                      )
                    )
                  (not (= ?ov ?md))
                  )
                )
              )
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?ox Real)
            (declare-const ?oy Real)
            (check-sat)
            (pop 1)
          (push 1)
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?oz Real)
          (assert
            (not (= ?oz ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?pa Real)
          (declare-const ?pb Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?pb ?lu)
                    )
                  (and (not (= ?pb ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?pa ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?pc Real)
        (assert
          (not (= ?pc ?lt))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?pd Real)
          (assert
            (not (= ?pd ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?pe Real)
          (declare-const ?pf Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?pf ?lu)
                    )
                  (and (not (= ?pf ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?pe ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?pg Real)
          (declare-const ?ph Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?pi Real)
        (declare-const ?pj Real)
        (assert
          (exists ((?md Real) )(and (or (and (= ?md ?lt)
                  (= ?pj ?lu)
                  )
                (and (not (= ?pj ?lt))
                  (= ?md ?lu)
                  )
                )
              (not (= ?pi ?md))
              )
            )
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?pk Real)
          (assert
            (not (= ?pk ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?pl Real)
          (declare-const ?pm Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?pm ?lu)
                    )
                  (and (not (= ?pm ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?pl ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?pn Real)
          (declare-const ?po Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?pp Real)
        (declare-const ?pq Real)
        (push 1)
          (declare-const ?pr Real)
          (assert
            (not (= ?pr ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ps Real)
          (declare-const ?pt Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?pt ?lu)
                    )
                  (and (not (= ?pt ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?ps ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?pu Real)
        (declare-const ?pv Real)
        (push 1)
          (declare-const ?pw Real)
          (assert
            (not (= ?pw ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?px Real)
          (declare-const ?py Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?py ?lu)
                    )
                  (and (not (= ?py ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?px ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?pz Real)
          (assert
            (not (= ?pz ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?qa Real)
          (declare-const ?qb Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?qb ?lu)
                    )
                  (and (not (= ?qb ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?qa ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?qc Real)
        (assert
          (not (= ?qc ?lt))
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?qd Real)
          (assert
            (not (= ?qd ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?qe Real)
          (declare-const ?qf Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?qf ?lu)
                    )
                  (and (not (= ?qf ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?qe ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?qg Real)
          (declare-const ?qh Real)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?qi Real)
          (declare-const ?qj Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?qk Real)
        (declare-const ?ql Real)
        (assert
          (exists ((?md Real) )(and (or (and (= ?md ?lt)
                  (= ?ql ?lu)
                  )
                (and (not (= ?ql ?lt))
                  (= ?md ?lu)
                  )
                )
              (not (= ?qk ?md))
              )
            )
          )
        (check-sat)
        (push 1)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?qm Real)
          (assert
            (not (= ?qm ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?qn Real)
          (declare-const ?qo Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?qo ?lu)
                    )
                  (and (not (= ?qo ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?qn ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?qp Real)
          (declare-const ?qq Real)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?qr Real)
          (declare-const ?qs Real)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?qt Real)
        (declare-const ?qu Real)
        (push 1)
          (declare-const ?qv Real)
          (assert
            (not (= ?qv ?lt))
            )
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?qw Real)
          (declare-const ?qx Real)
          (assert
            (exists ((?md Real) )(and (or (and (= ?md ?lt)
                    (= ?qx ?lu)
                    )
                  (and (not (= ?qx ?lt))
                    (= ?md ?lu)
                    )
                  )
                (not (= ?qw ?md))
                )
              )
            )
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?qy Real)
        (assert
          (not (= ?qy ?lt))
          )
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?qz Real)
        (declare-const ?ra Real)
        (assert
          (exists ((?md Real) )(and (or (and (= ?md ?lt)
                  (= ?ra ?lu)
                  )
                (and (not (= ?ra ?lt))
                  (= ?md ?lu)
                  )
                )
              (not (= ?qz ?md))
              )
            )
          )
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?rb Real)
        (assert
          (not (= ?rb ?lt))
          )
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?rc Real)
        (declare-const ?rd Real)
        (assert
          (exists ((?md Real) )(and (or (and (= ?md ?lt)
                  (= ?rd ?lu)
                  )
                (and (not (= ?rd ?lt))
                  (= ?md ?lu)
                  )
                )
              (not (= ?rc ?md))
              )
            )
          )
        (check-sat)
        (exit)

